=begin
#CryptoAPIs

#Crypto APIs 2.0 is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs 2.0 can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs 2.0 provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.

The version of the OpenAPI document: 2.0.0
Contact: developers@cryptoapis.io
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.1-SNAPSHOT

=end

# Common files
require 'crypto_apis/api_client'
require 'crypto_apis/api_error'
require 'crypto_apis/version'
require 'crypto_apis/configuration'

# Models
require 'crypto_apis/models/add_tokens_to_existing_from_address_r'
require 'crypto_apis/models/add_tokens_to_existing_from_address_rb'
require 'crypto_apis/models/add_tokens_to_existing_from_address_rb_data'
require 'crypto_apis/models/add_tokens_to_existing_from_address_rb_data_item'
require 'crypto_apis/models/add_tokens_to_existing_from_address_rb_token_data'
require 'crypto_apis/models/add_tokens_to_existing_from_address_rb_token_data_bitcoin_omni_token'
require 'crypto_apis/models/add_tokens_to_existing_from_address_rb_token_data_ethereum_erc20_token'
require 'crypto_apis/models/add_tokens_to_existing_from_address_r_data'
require 'crypto_apis/models/add_tokens_to_existing_from_address_ri'
require 'crypto_apis/models/add_tokens_to_existing_from_address_rits'
require 'crypto_apis/models/add_tokens_to_existing_from_address_ritsbot'
require 'crypto_apis/models/add_tokens_to_existing_from_address_ritseet'
require 'crypto_apis/models/address_coins_transaction_confirmed'
require 'crypto_apis/models/address_coins_transaction_confirmed_data'
require 'crypto_apis/models/address_coins_transaction_confirmed_data_item'
require 'crypto_apis/models/address_coins_transaction_confirmed_data_item_mined_in_block'
require 'crypto_apis/models/address_coins_transaction_confirmed_each_confirmation'
require 'crypto_apis/models/address_coins_transaction_confirmed_each_confirmation_data'
require 'crypto_apis/models/address_coins_transaction_confirmed_each_confirmation_data_item'
require 'crypto_apis/models/address_coins_transaction_confirmed_each_confirmation_data_item_mined_in_block'
require 'crypto_apis/models/address_coins_transaction_unconfirmed'
require 'crypto_apis/models/address_coins_transaction_unconfirmed_data'
require 'crypto_apis/models/address_coins_transaction_unconfirmed_data_item'
require 'crypto_apis/models/address_tokens_transaction_confirmed'
require 'crypto_apis/models/address_tokens_transaction_confirmed_data'
require 'crypto_apis/models/address_tokens_transaction_confirmed_data_item'
require 'crypto_apis/models/address_tokens_transaction_confirmed_data_item_mined_in_block'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation_data'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation_data_item'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation_data_item_mined_in_block'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation_ethereumerc20token'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation_ethereumerc721token'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation_omnilayertoken'
require 'crypto_apis/models/address_tokens_transaction_confirmed_each_confirmation_token'
require 'crypto_apis/models/address_tokens_transaction_confirmed_ethereumerc20token'
require 'crypto_apis/models/address_tokens_transaction_confirmed_ethereumerc721token'
require 'crypto_apis/models/address_tokens_transaction_confirmed_omnilayertoken'
require 'crypto_apis/models/address_tokens_transaction_confirmed_token'
require 'crypto_apis/models/address_tokens_transaction_unconfirmed'
require 'crypto_apis/models/address_tokens_transaction_unconfirmed_data'
require 'crypto_apis/models/address_tokens_transaction_unconfirmed_data_item'
require 'crypto_apis/models/address_tokens_transaction_unconfirmed_ethereumerc20token'
require 'crypto_apis/models/address_tokens_transaction_unconfirmed_ethereumerc721token'
require 'crypto_apis/models/address_tokens_transaction_unconfirmed_omnilayertoken'
require 'crypto_apis/models/address_tokens_transaction_unconfirmed_token'
require 'crypto_apis/models/already_exists'
require 'crypto_apis/models/already_exists_error'
require 'crypto_apis/models/banned_ip_address'
require 'crypto_apis/models/banned_ip_address_error'
require 'crypto_apis/models/banned_ip_address_error_details'
require 'crypto_apis/models/block_mined'
require 'crypto_apis/models/block_mined_data'
require 'crypto_apis/models/block_mined_data_item'
require 'crypto_apis/models/blockchain_data_block_not_found'
require 'crypto_apis/models/blockchain_data_block_not_found_error'
require 'crypto_apis/models/blockchain_data_internal_transaction_not_found'
require 'crypto_apis/models/blockchain_data_internal_transaction_not_found_error'
require 'crypto_apis/models/blockchain_data_transaction_not_found'
require 'crypto_apis/models/blockchain_data_transaction_not_found_error'
require 'crypto_apis/models/blockchain_events_callbacks_limit_reached'
require 'crypto_apis/models/blockchain_events_callbacks_limit_reached_error'
require 'crypto_apis/models/broadcast_locally_signed_transaction_r'
require 'crypto_apis/models/broadcast_locally_signed_transaction_rb'
require 'crypto_apis/models/broadcast_locally_signed_transaction_rb_data'
require 'crypto_apis/models/broadcast_locally_signed_transaction_rb_data_item'
require 'crypto_apis/models/broadcast_locally_signed_transaction_r_data'
require 'crypto_apis/models/broadcast_locally_signed_transaction_ri'
require 'crypto_apis/models/broadcast_transaction_fail'
require 'crypto_apis/models/broadcast_transaction_fail_data'
require 'crypto_apis/models/broadcast_transaction_fail_data_item'
require 'crypto_apis/models/broadcast_transaction_success'
require 'crypto_apis/models/broadcast_transaction_success_data'
require 'crypto_apis/models/broadcast_transaction_success_data_item'
require 'crypto_apis/models/coins_forwarding_automations_limit_reached'
require 'crypto_apis/models/coins_forwarding_automations_limit_reached_error'
require 'crypto_apis/models/coins_forwarding_fail'
require 'crypto_apis/models/coins_forwarding_fail_data'
require 'crypto_apis/models/coins_forwarding_fail_data_item'
require 'crypto_apis/models/coins_forwarding_success'
require 'crypto_apis/models/coins_forwarding_success_data'
require 'crypto_apis/models/coins_forwarding_success_data_item'
require 'crypto_apis/models/could_not_calculate_rate_for_pair'
require 'crypto_apis/models/could_not_calculate_rate_for_pair_error'
require 'crypto_apis/models/create_automatic_coins_forwarding_r'
require 'crypto_apis/models/create_automatic_coins_forwarding_rb'
require 'crypto_apis/models/create_automatic_coins_forwarding_rb_data'
require 'crypto_apis/models/create_automatic_coins_forwarding_rb_data_item'
require 'crypto_apis/models/create_automatic_coins_forwarding_r_data'
require 'crypto_apis/models/create_automatic_coins_forwarding_ri'
require 'crypto_apis/models/create_automatic_tokens_forwarding_r'
require 'crypto_apis/models/create_automatic_tokens_forwarding_rb'
require 'crypto_apis/models/create_automatic_tokens_forwarding_rb_data'
require 'crypto_apis/models/create_automatic_tokens_forwarding_rb_data_item'
require 'crypto_apis/models/create_automatic_tokens_forwarding_rb_token_data'
require 'crypto_apis/models/create_automatic_tokens_forwarding_rb_token_data_bitcoin_omni_token'
require 'crypto_apis/models/create_automatic_tokens_forwarding_rb_token_data_ethereum_token'
require 'crypto_apis/models/create_automatic_tokens_forwarding_r_data'
require 'crypto_apis/models/create_automatic_tokens_forwarding_ri'
require 'crypto_apis/models/create_automatic_tokens_forwarding_rits'
require 'crypto_apis/models/create_automatic_tokens_forwarding_ritsbot'
require 'crypto_apis/models/create_automatic_tokens_forwarding_ritset'
require 'crypto_apis/models/create_coins_transaction_request_from_address_r'
require 'crypto_apis/models/create_coins_transaction_request_from_address_rb'
require 'crypto_apis/models/create_coins_transaction_request_from_address_rb_data'
require 'crypto_apis/models/create_coins_transaction_request_from_address_rb_data_item'
require 'crypto_apis/models/create_coins_transaction_request_from_address_r_data'
require 'crypto_apis/models/create_coins_transaction_request_from_address_ri'
require 'crypto_apis/models/create_coins_transaction_request_from_address_ri_recipients'
require 'crypto_apis/models/create_coins_transaction_request_from_address_ri_senders'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_r'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_rb'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_rb_data'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_rb_data_item'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_rb_data_item_recipients'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_r_data'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_ri'
require 'crypto_apis/models/create_coins_transaction_request_from_wallet_ri_recipients'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_r'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_rb'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_rb_data'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_rb_data_item'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_r_data'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_ri'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_ri_recipients'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_ris'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_risb'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_rise'
require 'crypto_apis/models/create_tokens_transaction_request_from_address_ri_senders'
require 'crypto_apis/models/delete_automatic_coins_forwarding_r'
require 'crypto_apis/models/delete_automatic_coins_forwarding_r_data'
require 'crypto_apis/models/delete_automatic_coins_forwarding_ri'
require 'crypto_apis/models/delete_automatic_tokens_forwarding_r'
require 'crypto_apis/models/delete_automatic_tokens_forwarding_r_data'
require 'crypto_apis/models/delete_automatic_tokens_forwarding_ri'
require 'crypto_apis/models/delete_automatic_tokens_forwarding_rits'
require 'crypto_apis/models/delete_automatic_tokens_forwarding_ritsbot'
require 'crypto_apis/models/delete_automatic_tokens_forwarding_ritset'
require 'crypto_apis/models/delete_blockchain_event_subscription_r'
require 'crypto_apis/models/delete_blockchain_event_subscription_r_data'
require 'crypto_apis/models/delete_blockchain_event_subscription_ri'
require 'crypto_apis/models/endpoint_not_allowed_for_api_key'
require 'crypto_apis/models/endpoint_not_allowed_for_api_key_error'
require 'crypto_apis/models/endpoint_not_allowed_for_plan'
require 'crypto_apis/models/endpoint_not_allowed_for_plan_error'
require 'crypto_apis/models/feature_mainnets_not_allowed_for_plan'
require 'crypto_apis/models/feature_mainnets_not_allowed_for_plan_error'
require 'crypto_apis/models/generate_deposit_address_r'
require 'crypto_apis/models/generate_deposit_address_rb'
require 'crypto_apis/models/generate_deposit_address_rb_data'
require 'crypto_apis/models/generate_deposit_address_rb_data_item'
require 'crypto_apis/models/generate_deposit_address_r_data'
require 'crypto_apis/models/generate_deposit_address_ri'
require 'crypto_apis/models/get_address_details_r'
require 'crypto_apis/models/get_address_details_r_data'
require 'crypto_apis/models/get_address_details_ri'
require 'crypto_apis/models/get_address_details_ri_confirmed_balance'
require 'crypto_apis/models/get_address_details_ri_total_received'
require 'crypto_apis/models/get_address_details_ri_total_spent'
require 'crypto_apis/models/get_block_details_by_block_hash_r'
require 'crypto_apis/models/get_block_details_by_block_hash_r_data'
require 'crypto_apis/models/get_block_details_by_block_hash_ri'
require 'crypto_apis/models/get_block_details_by_block_hash_ribs'
require 'crypto_apis/models/get_block_details_by_block_hash_ribsb'
require 'crypto_apis/models/get_block_details_by_block_hash_ribsbc'
require 'crypto_apis/models/get_block_details_by_block_hash_ribsd'
require 'crypto_apis/models/get_block_details_by_block_hash_ribsd2'
require 'crypto_apis/models/get_block_details_by_block_hash_ribse'
require 'crypto_apis/models/get_block_details_by_block_hash_ribsec'
require 'crypto_apis/models/get_block_details_by_block_hash_ribsl'
require 'crypto_apis/models/get_block_details_by_block_height_r'
require 'crypto_apis/models/get_block_details_by_block_height_r_data'
require 'crypto_apis/models/get_block_details_by_block_height_ri'
require 'crypto_apis/models/get_block_details_by_block_height_ribs'
require 'crypto_apis/models/get_block_details_by_block_height_ribsb'
require 'crypto_apis/models/get_block_details_by_block_height_ribsbc'
require 'crypto_apis/models/get_block_details_by_block_height_ribsd'
require 'crypto_apis/models/get_block_details_by_block_height_ribsd2'
require 'crypto_apis/models/get_block_details_by_block_height_ribse'
require 'crypto_apis/models/get_block_details_by_block_height_ribsec'
require 'crypto_apis/models/get_block_details_by_block_height_ribsl'
require 'crypto_apis/models/get_contract_details_by_address_r'
require 'crypto_apis/models/get_contract_details_by_address_r_data'
require 'crypto_apis/models/get_contract_details_by_address_ri'
require 'crypto_apis/models/get_exchange_rate_by_asset_symbols_r'
require 'crypto_apis/models/get_exchange_rate_by_asset_symbols_r_data'
require 'crypto_apis/models/get_exchange_rate_by_asset_symbols_ri'
require 'crypto_apis/models/get_exchange_rate_by_assets_ids_r'
require 'crypto_apis/models/get_exchange_rate_by_assets_ids_r_data'
require 'crypto_apis/models/get_exchange_rate_by_assets_ids_ri'
require 'crypto_apis/models/get_fee_address_details_r'
require 'crypto_apis/models/get_fee_address_details_r_data'
require 'crypto_apis/models/get_fee_address_details_ri'
require 'crypto_apis/models/get_fee_address_details_ri_balance'
require 'crypto_apis/models/get_fee_recommendations_r'
require 'crypto_apis/models/get_fee_recommendations_r_data'
require 'crypto_apis/models/get_fee_recommendations_ri'
require 'crypto_apis/models/get_hd_wallet_x_pub_y_pub_z_pub_details_r'
require 'crypto_apis/models/get_hd_wallet_x_pub_y_pub_z_pub_details_r_data'
require 'crypto_apis/models/get_hd_wallet_x_pub_y_pub_z_pub_details_ri'
require 'crypto_apis/models/get_internal_transaction_by_transaction_hash_and_operation_id_r'
require 'crypto_apis/models/get_internal_transaction_by_transaction_hash_and_operation_id_r_data'
require 'crypto_apis/models/get_internal_transaction_by_transaction_hash_and_operation_id_ri'
require 'crypto_apis/models/get_latest_mined_block_r'
require 'crypto_apis/models/get_latest_mined_block_r_data'
require 'crypto_apis/models/get_latest_mined_block_ri'
require 'crypto_apis/models/get_latest_mined_block_ribs'
require 'crypto_apis/models/get_latest_mined_block_ribsb'
require 'crypto_apis/models/get_latest_mined_block_ribsbc'
require 'crypto_apis/models/get_latest_mined_block_ribsd'
require 'crypto_apis/models/get_latest_mined_block_ribsd2'
require 'crypto_apis/models/get_latest_mined_block_ribse'
require 'crypto_apis/models/get_latest_mined_block_ribsec'
require 'crypto_apis/models/get_latest_mined_block_ribsl'
require 'crypto_apis/models/get_latest_mined_xrp_ripple_block_r'
require 'crypto_apis/models/get_latest_mined_xrp_ripple_block_r_data'
require 'crypto_apis/models/get_latest_mined_xrp_ripple_block_ri'
require 'crypto_apis/models/get_latest_mined_xrp_ripple_block_ri_total_coins'
require 'crypto_apis/models/get_latest_mined_xrp_ripple_block_ri_total_fees'
require 'crypto_apis/models/get_latest_mined_zilliqa_block_r'
require 'crypto_apis/models/get_latest_mined_zilliqa_block_r_data'
require 'crypto_apis/models/get_latest_mined_zilliqa_block_ri'
require 'crypto_apis/models/get_omni_transaction_details_by_transaction_id_txid_r'
require 'crypto_apis/models/get_omni_transaction_details_by_transaction_id_txid_r_data'
require 'crypto_apis/models/get_omni_transaction_details_by_transaction_id_txid_ri'
require 'crypto_apis/models/get_omni_transaction_details_by_transaction_id_txid_ri_senders'
require 'crypto_apis/models/get_transaction_details_by_transaction_idr'
require 'crypto_apis/models/get_transaction_details_by_transaction_idr_data'
require 'crypto_apis/models/get_transaction_details_by_transaction_idri'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribs'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsb'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsbc'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsbc_script_pub_key'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsbc_vin'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsbc_vout'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsb_script_pub_key'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsb_script_sig'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsb_vin'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsb_vout'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd2'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd2_script_pub_key'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd2_script_sig'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd2_vin'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd2_vout'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd_script_pub_key'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd_script_sig'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd_vin'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsd_vout'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribse'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsec'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsec_gas_price'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribse_gas_price'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsl'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsl_script_pub_key'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsl_script_sig'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsl_vin'
require 'crypto_apis/models/get_transaction_details_by_transaction_idribsl_vout'
require 'crypto_apis/models/get_transaction_details_by_transaction_idri_fee'
require 'crypto_apis/models/get_transaction_details_by_transaction_idri_recipients'
require 'crypto_apis/models/get_transaction_details_by_transaction_idri_senders'
require 'crypto_apis/models/get_unconfirmed_omni_transaction_by_transaction_id_txid_r'
require 'crypto_apis/models/get_unconfirmed_omni_transaction_by_transaction_id_txid_r_data'
require 'crypto_apis/models/get_unconfirmed_omni_transaction_by_transaction_id_txid_ri'
require 'crypto_apis/models/get_unconfirmed_omni_transaction_by_transaction_id_txid_ri_recipients'
require 'crypto_apis/models/get_unconfirmed_omni_transaction_by_transaction_id_txid_ri_senders'
require 'crypto_apis/models/get_wallet_asset_details_r'
require 'crypto_apis/models/get_wallet_asset_details_r_data'
require 'crypto_apis/models/get_wallet_asset_details_ri'
require 'crypto_apis/models/get_wallet_asset_details_ri_confirmed_balance'
require 'crypto_apis/models/get_wallet_asset_details_ri_recieved_confirmed_amount'
require 'crypto_apis/models/get_wallet_asset_details_ri_sent_confirmed_amount'
require 'crypto_apis/models/get_xrp_ripple_address_details_r'
require 'crypto_apis/models/get_xrp_ripple_address_details_r_data'
require 'crypto_apis/models/get_xrp_ripple_address_details_ri'
require 'crypto_apis/models/get_xrp_ripple_address_details_ri_balance'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_hash_r'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_hash_r_data'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_hash_ri'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_hash_ri_total_coins'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_height_r'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_height_r_data'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_height_ri'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_height_ri_total_coins'
require 'crypto_apis/models/get_xrp_ripple_block_details_by_block_height_ri_total_fees'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idr'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idr_data'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idri'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idri_fee'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idri_offer'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idri_receive'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idri_recipients'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idri_senders'
require 'crypto_apis/models/get_xrp_ripple_transaction_details_by_transaction_idri_value'
require 'crypto_apis/models/get_zilliqa_address_details_r'
require 'crypto_apis/models/get_zilliqa_address_details_r_data'
require 'crypto_apis/models/get_zilliqa_address_details_ri'
require 'crypto_apis/models/get_zilliqa_address_details_ri_balance'
require 'crypto_apis/models/get_zilliqa_block_details_by_block_hash_r'
require 'crypto_apis/models/get_zilliqa_block_details_by_block_hash_r_data'
require 'crypto_apis/models/get_zilliqa_block_details_by_block_hash_ri'
require 'crypto_apis/models/get_zilliqa_block_details_by_block_height_r'
require 'crypto_apis/models/get_zilliqa_block_details_by_block_height_r_data'
require 'crypto_apis/models/get_zilliqa_block_details_by_block_height_ri'
require 'crypto_apis/models/get_zilliqa_transaction_details_by_transaction_idr'
require 'crypto_apis/models/get_zilliqa_transaction_details_by_transaction_idr_data'
require 'crypto_apis/models/get_zilliqa_transaction_details_by_transaction_idri'
require 'crypto_apis/models/get_zilliqa_transaction_details_by_transaction_idri_fee'
require 'crypto_apis/models/get_zilliqa_transaction_details_by_transaction_idri_recipients'
require 'crypto_apis/models/get_zilliqa_transaction_details_by_transaction_idri_senders'
require 'crypto_apis/models/insufficient_credits'
require 'crypto_apis/models/insufficient_credits_error'
require 'crypto_apis/models/invalid_api_key'
require 'crypto_apis/models/invalid_api_key_error'
require 'crypto_apis/models/invalid_blockchain'
require 'crypto_apis/models/invalid_blockchain_error'
require 'crypto_apis/models/invalid_data'
require 'crypto_apis/models/invalid_data_error'
require 'crypto_apis/models/invalid_network'
require 'crypto_apis/models/invalid_network_error'
require 'crypto_apis/models/invalid_pagination'
require 'crypto_apis/models/invalid_pagination_error'
require 'crypto_apis/models/invalid_request_body_structure'
require 'crypto_apis/models/invalid_request_body_structure_error'
require 'crypto_apis/models/invalid_xpub'
require 'crypto_apis/models/invalid_xpub_error'
require 'crypto_apis/models/limit_greater_than_allowed'
require 'crypto_apis/models/limit_greater_than_allowed_error'
require 'crypto_apis/models/list_assets_details_r'
require 'crypto_apis/models/list_assets_details_r_data'
require 'crypto_apis/models/list_assets_details_ri'
require 'crypto_apis/models/list_assets_details_ri_asset_logo'
require 'crypto_apis/models/list_assets_details_ri_latest_rate'
require 'crypto_apis/models/list_assets_details_ris'
require 'crypto_apis/models/list_assets_details_risc'
require 'crypto_apis/models/list_blockchain_events_subscriptions_r'
require 'crypto_apis/models/list_blockchain_events_subscriptions_r_data'
require 'crypto_apis/models/list_blockchain_events_subscriptions_ri'
require 'crypto_apis/models/list_coins_forwarding_automations_r'
require 'crypto_apis/models/list_coins_forwarding_automations_r_data'
require 'crypto_apis/models/list_coins_forwarding_automations_ri'
require 'crypto_apis/models/list_deposit_addresses_r'
require 'crypto_apis/models/list_deposit_addresses_r_data'
require 'crypto_apis/models/list_deposit_addresses_ri'
require 'crypto_apis/models/list_hd_wallet_x_pub_y_pub_z_pub_transactions_r'
require 'crypto_apis/models/list_hd_wallet_x_pub_y_pub_z_pub_transactions_r_data'
require 'crypto_apis/models/list_hd_wallet_x_pub_y_pub_z_pub_transactions_ri'
require 'crypto_apis/models/list_hd_wallet_x_pub_y_pub_z_pub_transactions_ri_fee'
require 'crypto_apis/models/list_hd_wallet_x_pub_y_pub_z_pub_transactions_ri_recipients'
require 'crypto_apis/models/list_hd_wallet_x_pub_y_pub_z_pub_transactions_ri_senders'
require 'crypto_apis/models/list_internal_transaction_details_by_transaction_hash_r'
require 'crypto_apis/models/list_internal_transaction_details_by_transaction_hash_r_data'
require 'crypto_apis/models/list_internal_transaction_details_by_transaction_hash_ri'
require 'crypto_apis/models/list_omni_tokens_by_address_r'
require 'crypto_apis/models/list_omni_tokens_by_address_r_data'
require 'crypto_apis/models/list_omni_tokens_by_address_ri'
require 'crypto_apis/models/list_omni_transactions_by_address_r'
require 'crypto_apis/models/list_omni_transactions_by_address_r_data'
require 'crypto_apis/models/list_omni_transactions_by_address_ri'
require 'crypto_apis/models/list_omni_transactions_by_address_ri_fee'
require 'crypto_apis/models/list_omni_transactions_by_address_ri_recipients'
require 'crypto_apis/models/list_omni_transactions_by_address_ri_senders'
require 'crypto_apis/models/list_omni_transactions_by_block_hash_r'
require 'crypto_apis/models/list_omni_transactions_by_block_hash_r_data'
require 'crypto_apis/models/list_omni_transactions_by_block_hash_ri'
require 'crypto_apis/models/list_omni_transactions_by_block_hash_ri_fee'
require 'crypto_apis/models/list_omni_transactions_by_block_height_r'
require 'crypto_apis/models/list_omni_transactions_by_block_height_r_data'
require 'crypto_apis/models/list_omni_transactions_by_block_height_ri'
require 'crypto_apis/models/list_omni_transactions_by_block_height_ri_fee'
require 'crypto_apis/models/list_omni_transactions_by_block_height_ri_recipients'
require 'crypto_apis/models/list_omni_transactions_by_block_height_ri_senders'
require 'crypto_apis/models/list_supported_assets_r'
require 'crypto_apis/models/list_supported_assets_r_data'
require 'crypto_apis/models/list_supported_assets_ri'
require 'crypto_apis/models/list_supported_tokens_r'
require 'crypto_apis/models/list_supported_tokens_r_data'
require 'crypto_apis/models/list_supported_tokens_ri'
require 'crypto_apis/models/list_tokens_by_address_r'
require 'crypto_apis/models/list_tokens_by_address_r_data'
require 'crypto_apis/models/list_tokens_by_address_ri'
require 'crypto_apis/models/list_tokens_forwarding_automations_r'
require 'crypto_apis/models/list_tokens_forwarding_automations_r_data'
require 'crypto_apis/models/list_tokens_forwarding_automations_ri'
require 'crypto_apis/models/list_tokens_forwarding_automations_rits'
require 'crypto_apis/models/list_tokens_forwarding_automations_ritsbot'
require 'crypto_apis/models/list_tokens_forwarding_automations_ritset'
require 'crypto_apis/models/list_tokens_transfers_by_address_r'
require 'crypto_apis/models/list_tokens_transfers_by_address_r_data'
require 'crypto_apis/models/list_tokens_transfers_by_address_ri'
require 'crypto_apis/models/list_tokens_transfers_by_transaction_hash_r'
require 'crypto_apis/models/list_tokens_transfers_by_transaction_hash_r_data'
require 'crypto_apis/models/list_tokens_transfers_by_transaction_hash_ri'
require 'crypto_apis/models/list_transactions_by_address_r'
require 'crypto_apis/models/list_transactions_by_address_r_data'
require 'crypto_apis/models/list_transactions_by_address_ri'
require 'crypto_apis/models/list_transactions_by_address_ribs'
require 'crypto_apis/models/list_transactions_by_address_ribsb'
require 'crypto_apis/models/list_transactions_by_address_ribsbc'
require 'crypto_apis/models/list_transactions_by_address_ribsbc_vin'
require 'crypto_apis/models/list_transactions_by_address_ribsb_script_pub_key'
require 'crypto_apis/models/list_transactions_by_address_ribsb_vin'
require 'crypto_apis/models/list_transactions_by_address_ribsb_vout'
require 'crypto_apis/models/list_transactions_by_address_ribsd'
require 'crypto_apis/models/list_transactions_by_address_ribsd2'
require 'crypto_apis/models/list_transactions_by_address_ribsd2_script_pub_key'
require 'crypto_apis/models/list_transactions_by_address_ribsd2_script_sig'
require 'crypto_apis/models/list_transactions_by_address_ribsd2_vin'
require 'crypto_apis/models/list_transactions_by_address_ribsd2_vout'
require 'crypto_apis/models/list_transactions_by_address_ribsd_script_sig'
require 'crypto_apis/models/list_transactions_by_address_ribsd_vin'
require 'crypto_apis/models/list_transactions_by_address_ribse'
require 'crypto_apis/models/list_transactions_by_address_ribsec'
require 'crypto_apis/models/list_transactions_by_address_ribsec_gas_price'
require 'crypto_apis/models/list_transactions_by_address_ribse_gas_price'
require 'crypto_apis/models/list_transactions_by_address_ribsl'
require 'crypto_apis/models/list_transactions_by_address_ribsl_script_sig'
require 'crypto_apis/models/list_transactions_by_address_ribsl_vin'
require 'crypto_apis/models/list_transactions_by_block_hash_r'
require 'crypto_apis/models/list_transactions_by_block_hash_r_data'
require 'crypto_apis/models/list_transactions_by_block_hash_ri'
require 'crypto_apis/models/list_transactions_by_block_hash_ribs'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsb'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsbc'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsbc_script_pub_key'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsbc_vin'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsbc_vout'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsb_vin'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd2'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd2_script_pub_key'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd2_script_sig'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd2_vin'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd2_vout'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd_script_pub_key'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd_vin'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsd_vout'
require 'crypto_apis/models/list_transactions_by_block_hash_ribse'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsec'
require 'crypto_apis/models/list_transactions_by_block_hash_ribse_gas_price'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsl'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsl_script_pub_key'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsl_vin'
require 'crypto_apis/models/list_transactions_by_block_hash_ribsl_vout'
require 'crypto_apis/models/list_transactions_by_block_hash_ri_fee'
require 'crypto_apis/models/list_transactions_by_block_hash_ri_recipients'
require 'crypto_apis/models/list_transactions_by_block_hash_ri_senders'
require 'crypto_apis/models/list_transactions_by_block_height_r'
require 'crypto_apis/models/list_transactions_by_block_height_r_data'
require 'crypto_apis/models/list_transactions_by_block_height_ri'
require 'crypto_apis/models/list_transactions_by_block_height_ribs'
require 'crypto_apis/models/list_transactions_by_block_height_ribsb'
require 'crypto_apis/models/list_transactions_by_block_height_ribsbc'
require 'crypto_apis/models/list_transactions_by_block_height_ribsb_script_pub_key'
require 'crypto_apis/models/list_transactions_by_block_height_ribsb_vout'
require 'crypto_apis/models/list_transactions_by_block_height_ribsd'
require 'crypto_apis/models/list_transactions_by_block_height_ribsd2'
require 'crypto_apis/models/list_transactions_by_block_height_ribsd2_vin'
require 'crypto_apis/models/list_transactions_by_block_height_ribsd_script_pub_key'
require 'crypto_apis/models/list_transactions_by_block_height_ribsd_script_sig'
require 'crypto_apis/models/list_transactions_by_block_height_ribsd_vin'
require 'crypto_apis/models/list_transactions_by_block_height_ribsd_vout'
require 'crypto_apis/models/list_transactions_by_block_height_ribse'
require 'crypto_apis/models/list_transactions_by_block_height_ribsec'
require 'crypto_apis/models/list_transactions_by_block_height_ribsec_gas_price'
require 'crypto_apis/models/list_transactions_by_block_height_ribsl'
require 'crypto_apis/models/list_transactions_by_block_height_ribsl_script_pub_key'
require 'crypto_apis/models/list_transactions_by_block_height_ribsl_script_sig'
require 'crypto_apis/models/list_transactions_by_block_height_ribsl_vin'
require 'crypto_apis/models/list_transactions_by_block_height_ribsl_vout'
require 'crypto_apis/models/list_transactions_by_block_height_ri_fee'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_address_r'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_address_r_data'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_address_ri'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_address_ri_fee'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_address_ri_senders'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_property_idr'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_property_idr_data'
require 'crypto_apis/models/list_unconfirmed_omni_transactions_by_property_idri'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_address_r'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_address_r_data'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_address_ri'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_address_ri_fee'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_address_ri_offer'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_address_ri_receive'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_address_ri_value'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_r'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_r_data'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_ri'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_ri_fee'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_ri_offer'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_ri_receive'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_ri_recipients'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_ri_senders'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_hash_ri_value'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_r'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_r_data'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_ri'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_ri_fee'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_ri_offer'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_ri_receive'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_ri_recipients'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_ri_senders'
require 'crypto_apis/models/list_xrp_ripple_transactions_by_block_height_ri_value'
require 'crypto_apis/models/list_zilliqa_transactions_by_address_r'
require 'crypto_apis/models/list_zilliqa_transactions_by_address_r_data'
require 'crypto_apis/models/list_zilliqa_transactions_by_address_ri'
require 'crypto_apis/models/list_zilliqa_transactions_by_address_ri_recipients'
require 'crypto_apis/models/list_zilliqa_transactions_by_address_ri_senders'
require 'crypto_apis/models/list_zilliqa_transactions_by_block_hash_r'
require 'crypto_apis/models/list_zilliqa_transactions_by_block_hash_r_data'
require 'crypto_apis/models/list_zilliqa_transactions_by_block_hash_ri'
require 'crypto_apis/models/list_zilliqa_transactions_by_block_height_r'
require 'crypto_apis/models/list_zilliqa_transactions_by_block_height_r_data'
require 'crypto_apis/models/list_zilliqa_transactions_by_block_height_ri'
require 'crypto_apis/models/mined_transaction_r'
require 'crypto_apis/models/mined_transaction_rb'
require 'crypto_apis/models/mined_transaction_rb_data'
require 'crypto_apis/models/mined_transaction_rb_data_item'
require 'crypto_apis/models/mined_transaction_r_data'
require 'crypto_apis/models/mined_transaction_ri'
require 'crypto_apis/models/missing_api_key'
require 'crypto_apis/models/missing_api_key_error'
require 'crypto_apis/models/new_block_r'
require 'crypto_apis/models/new_block_rb'
require 'crypto_apis/models/new_block_rb_data'
require 'crypto_apis/models/new_block_rb_data_item'
require 'crypto_apis/models/new_block_r_data'
require 'crypto_apis/models/new_block_ri'
require 'crypto_apis/models/new_confirmed_coins_transactions_and_each_confirmation_r'
require 'crypto_apis/models/new_confirmed_coins_transactions_and_each_confirmation_rb'
require 'crypto_apis/models/new_confirmed_coins_transactions_and_each_confirmation_rb_data'
require 'crypto_apis/models/new_confirmed_coins_transactions_and_each_confirmation_rb_data_item'
require 'crypto_apis/models/new_confirmed_coins_transactions_and_each_confirmation_r_data'
require 'crypto_apis/models/new_confirmed_coins_transactions_and_each_confirmation_ri'
require 'crypto_apis/models/new_confirmed_coins_transactions_r'
require 'crypto_apis/models/new_confirmed_coins_transactions_rb'
require 'crypto_apis/models/new_confirmed_coins_transactions_rb_data'
require 'crypto_apis/models/new_confirmed_coins_transactions_rb_data_item'
require 'crypto_apis/models/new_confirmed_coins_transactions_r_data'
require 'crypto_apis/models/new_confirmed_coins_transactions_ri'
require 'crypto_apis/models/new_confirmed_internal_transactions_and_each_confirmation_r'
require 'crypto_apis/models/new_confirmed_internal_transactions_and_each_confirmation_rb'
require 'crypto_apis/models/new_confirmed_internal_transactions_and_each_confirmation_rb_data'
require 'crypto_apis/models/new_confirmed_internal_transactions_and_each_confirmation_rb_data_item'
require 'crypto_apis/models/new_confirmed_internal_transactions_and_each_confirmation_r_data'
require 'crypto_apis/models/new_confirmed_internal_transactions_and_each_confirmation_ri'
require 'crypto_apis/models/new_confirmed_internal_transactions_r'
require 'crypto_apis/models/new_confirmed_internal_transactions_rb'
require 'crypto_apis/models/new_confirmed_internal_transactions_rb_data'
require 'crypto_apis/models/new_confirmed_internal_transactions_rb_data_item'
require 'crypto_apis/models/new_confirmed_internal_transactions_r_data'
require 'crypto_apis/models/new_confirmed_internal_transactions_ri'
require 'crypto_apis/models/new_confirmed_tokens_transactions_and_each_confirmation_r'
require 'crypto_apis/models/new_confirmed_tokens_transactions_and_each_confirmation_rb'
require 'crypto_apis/models/new_confirmed_tokens_transactions_and_each_confirmation_rb_data'
require 'crypto_apis/models/new_confirmed_tokens_transactions_and_each_confirmation_rb_data_item'
require 'crypto_apis/models/new_confirmed_tokens_transactions_and_each_confirmation_r_data'
require 'crypto_apis/models/new_confirmed_tokens_transactions_and_each_confirmation_ri'
require 'crypto_apis/models/new_confirmed_tokens_transactions_r'
require 'crypto_apis/models/new_confirmed_tokens_transactions_rb'
require 'crypto_apis/models/new_confirmed_tokens_transactions_r_data'
require 'crypto_apis/models/new_confirmed_tokens_transactions_ri'
require 'crypto_apis/models/new_unconfirmed_coins_transactions_r'
require 'crypto_apis/models/new_unconfirmed_coins_transactions_rb'
require 'crypto_apis/models/new_unconfirmed_coins_transactions_rb_data'
require 'crypto_apis/models/new_unconfirmed_coins_transactions_rb_data_item'
require 'crypto_apis/models/new_unconfirmed_coins_transactions_r_data'
require 'crypto_apis/models/new_unconfirmed_coins_transactions_ri'
require 'crypto_apis/models/new_unconfirmed_tokens_transactions_r'
require 'crypto_apis/models/new_unconfirmed_tokens_transactions_rb'
require 'crypto_apis/models/new_unconfirmed_tokens_transactions_rb_data'
require 'crypto_apis/models/new_unconfirmed_tokens_transactions_rb_data_item'
require 'crypto_apis/models/new_unconfirmed_tokens_transactions_r_data'
require 'crypto_apis/models/new_unconfirmed_tokens_transactions_ri'
require 'crypto_apis/models/request_limit_reached'
require 'crypto_apis/models/request_limit_reached_error'
require 'crypto_apis/models/resource_not_found'
require 'crypto_apis/models/resource_not_found_error'
require 'crypto_apis/models/sync_hd_wallet_x_pub_y_pub_z_pub_r'
require 'crypto_apis/models/sync_hd_wallet_x_pub_y_pub_z_pub_rb'
require 'crypto_apis/models/sync_hd_wallet_x_pub_y_pub_z_pub_rb_data'
require 'crypto_apis/models/sync_hd_wallet_x_pub_y_pub_z_pub_rb_data_item'
require 'crypto_apis/models/sync_hd_wallet_x_pub_y_pub_z_pub_r_data'
require 'crypto_apis/models/sync_hd_wallet_x_pub_y_pub_z_pub_ri'
require 'crypto_apis/models/tokens_forwarding_automations_limit_reached'
require 'crypto_apis/models/tokens_forwarding_automations_limit_reached_error'
require 'crypto_apis/models/tokens_forwarding_fail'
require 'crypto_apis/models/tokens_forwarding_fail_data'
require 'crypto_apis/models/tokens_forwarding_fail_data_item'
require 'crypto_apis/models/tokens_forwarding_success'
require 'crypto_apis/models/tokens_forwarding_success_data'
require 'crypto_apis/models/tokens_forwarding_success_data_item'
require 'crypto_apis/models/tokens_forwarding_success_ethereumerc20token'
require 'crypto_apis/models/tokens_forwarding_success_ethereumerc721token'
require 'crypto_apis/models/tokens_forwarding_success_omnilayertoken'
require 'crypto_apis/models/tokens_forwarding_success_token'
require 'crypto_apis/models/transaction_mined'
require 'crypto_apis/models/transaction_mined_data'
require 'crypto_apis/models/transaction_mined_data_item'
require 'crypto_apis/models/transaction_mined_data_item_mined_in_block'
require 'crypto_apis/models/transaction_request_approval'
require 'crypto_apis/models/transaction_request_approval_data'
require 'crypto_apis/models/transaction_request_approval_data_item'
require 'crypto_apis/models/transaction_request_broadcasted'
require 'crypto_apis/models/transaction_request_broadcasted_data'
require 'crypto_apis/models/transaction_request_broadcasted_data_item'
require 'crypto_apis/models/transaction_request_fail'
require 'crypto_apis/models/transaction_request_fail_data'
require 'crypto_apis/models/transaction_request_fail_data_item'
require 'crypto_apis/models/transaction_request_mined'
require 'crypto_apis/models/transaction_request_mined_data'
require 'crypto_apis/models/transaction_request_rejection'
require 'crypto_apis/models/transaction_request_rejection_data'
require 'crypto_apis/models/transaction_request_rejection_data_item'
require 'crypto_apis/models/unexpected_server_error'
require 'crypto_apis/models/unexpected_server_error_error'
require 'crypto_apis/models/unsupported_media_type'
require 'crypto_apis/models/unsupported_media_type_error'
require 'crypto_apis/models/uri_not_found'
require 'crypto_apis/models/uri_not_found_error'
require 'crypto_apis/models/validate_address_r'
require 'crypto_apis/models/validate_address_rb'
require 'crypto_apis/models/validate_address_rb_data'
require 'crypto_apis/models/validate_address_rb_data_item'
require 'crypto_apis/models/validate_address_r_data'
require 'crypto_apis/models/validate_address_ri'
require 'crypto_apis/models/wallet_as_a_service_deposit_addresses_limit_reached'
require 'crypto_apis/models/wallet_as_a_service_deposit_addresses_limit_reached_error'
require 'crypto_apis/models/wallet_as_a_service_no_deposit_addresses_found'
require 'crypto_apis/models/wallet_as_a_service_no_deposit_addresses_found_error'
require 'crypto_apis/models/wallet_as_a_service_token_not_supported'
require 'crypto_apis/models/wallet_as_a_service_token_not_supported_error'
require 'crypto_apis/models/wallet_as_a_service_wallet_balance_not_enough'
require 'crypto_apis/models/wallet_as_a_service_wallet_balance_not_enough_error'
require 'crypto_apis/models/xpub_not_synced'
require 'crypto_apis/models/xpub_not_synced_error'
require 'crypto_apis/models/xpub_sync_in_progress'
require 'crypto_apis/models/xpub_sync_in_progress_error'

# APIs
require 'crypto_apis/api/assets_api'
require 'crypto_apis/api/automatic_coins_forwarding_api'
require 'crypto_apis/api/automatic_tokens_forwarding_api'
require 'crypto_apis/api/create_subscriptions_for_api'
require 'crypto_apis/api/exchange_rates_api'
require 'crypto_apis/api/features_api'
require 'crypto_apis/api/generating_api'
require 'crypto_apis/api/informative_api'
require 'crypto_apis/api/internal_api'
require 'crypto_apis/api/manage_subscriptions_api'
require 'crypto_apis/api/metadata_api'
require 'crypto_apis/api/omni_layer_api'
require 'crypto_apis/api/tokens_api'
require 'crypto_apis/api/transactions_api'
require 'crypto_apis/api/utxo_based_api'
require 'crypto_apis/api/unified_endpoints_api'
require 'crypto_apis/api/xrp_ripple_api'
require 'crypto_apis/api/zilliqa_api'

module CryptoApis
  class << self
    # Customize default settings for the SDK using block.
    #   CryptoApis.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
