=begin
#CryptoAPIs

#Crypto APIs 2.0 is a complex and innovative infrastructure layer that radically simplifies the development of any Blockchain and Crypto related applications. Organized around REST, Crypto APIs 2.0 can assist both novice Bitcoin/Ethereum enthusiasts and crypto experts with the development of their blockchain applications. Crypto APIs 2.0 provides unified endpoints and data, raw data, automatic tokens and coins forwardings, callback functionalities, and much more.

The version of the OpenAPI document: 2.0.0
Contact: developers@cryptoapis.io
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.2.1-SNAPSHOT

=end

require 'date'
require 'time'

module CryptoApis
  class ListZilliqaTransactionsByBlockHeightRI
    attr_accessor :fee

    # Represents the maximum amount of gas allowed in the block in order to determine how many transactions it can fit.
    attr_accessor :gas_limit

    # Defines the price of the gas.
    attr_accessor :gas_price

    # Defines how much of the gas for the block has been used.
    attr_accessor :gas_used

    # Represents the hash of the block, which is its unique identifier. It represents a cryptographic digital fingerprint made by hashing the block header twice through the SHA256 algorithm.
    attr_accessor :mined_in_block_hash

    # Represents a random value that can be adjusted to satisfy the Proof of Work.
    attr_accessor :nonce

    # Defines an object array of the transaction recipients.
    attr_accessor :recipients

    # Represents an object of addresses that provide the funds.
    attr_accessor :senders

    # Defines the exact date/time when this block was mined in Unix Timestamp.
    attr_accessor :timestamp

    # Represents the hash of the transaction, which is its unique identifier.
    attr_accessor :transaction_hash

    # Defines the numeric representation of the transaction index.
    attr_accessor :transaction_index

    # Defines the status of the transaction, whether it is e.g. pending or complete.
    attr_accessor :transaction_status

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'fee' => :'fee',
        :'gas_limit' => :'gasLimit',
        :'gas_price' => :'gasPrice',
        :'gas_used' => :'gasUsed',
        :'mined_in_block_hash' => :'minedInBlockHash',
        :'nonce' => :'nonce',
        :'recipients' => :'recipients',
        :'senders' => :'senders',
        :'timestamp' => :'timestamp',
        :'transaction_hash' => :'transactionHash',
        :'transaction_index' => :'transactionIndex',
        :'transaction_status' => :'transactionStatus'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'fee' => :'GetZilliqaTransactionDetailsByTransactionIDRIFee',
        :'gas_limit' => :'Integer',
        :'gas_price' => :'Integer',
        :'gas_used' => :'Integer',
        :'mined_in_block_hash' => :'String',
        :'nonce' => :'Integer',
        :'recipients' => :'Array<ListZilliqaTransactionsByAddressRIRecipients>',
        :'senders' => :'Array<ListZilliqaTransactionsByAddressRISenders>',
        :'timestamp' => :'Integer',
        :'transaction_hash' => :'String',
        :'transaction_index' => :'Integer',
        :'transaction_status' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `CryptoApis::ListZilliqaTransactionsByBlockHeightRI` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `CryptoApis::ListZilliqaTransactionsByBlockHeightRI`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'fee')
        self.fee = attributes[:'fee']
      end

      if attributes.key?(:'gas_limit')
        self.gas_limit = attributes[:'gas_limit']
      end

      if attributes.key?(:'gas_price')
        self.gas_price = attributes[:'gas_price']
      end

      if attributes.key?(:'gas_used')
        self.gas_used = attributes[:'gas_used']
      end

      if attributes.key?(:'mined_in_block_hash')
        self.mined_in_block_hash = attributes[:'mined_in_block_hash']
      end

      if attributes.key?(:'nonce')
        self.nonce = attributes[:'nonce']
      end

      if attributes.key?(:'recipients')
        if (value = attributes[:'recipients']).is_a?(Array)
          self.recipients = value
        end
      end

      if attributes.key?(:'senders')
        if (value = attributes[:'senders']).is_a?(Array)
          self.senders = value
        end
      end

      if attributes.key?(:'timestamp')
        self.timestamp = attributes[:'timestamp']
      end

      if attributes.key?(:'transaction_hash')
        self.transaction_hash = attributes[:'transaction_hash']
      end

      if attributes.key?(:'transaction_index')
        self.transaction_index = attributes[:'transaction_index']
      end

      if attributes.key?(:'transaction_status')
        self.transaction_status = attributes[:'transaction_status']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @fee.nil?
        invalid_properties.push('invalid value for "fee", fee cannot be nil.')
      end

      if @gas_limit.nil?
        invalid_properties.push('invalid value for "gas_limit", gas_limit cannot be nil.')
      end

      if @gas_price.nil?
        invalid_properties.push('invalid value for "gas_price", gas_price cannot be nil.')
      end

      if @gas_used.nil?
        invalid_properties.push('invalid value for "gas_used", gas_used cannot be nil.')
      end

      if @mined_in_block_hash.nil?
        invalid_properties.push('invalid value for "mined_in_block_hash", mined_in_block_hash cannot be nil.')
      end

      if @nonce.nil?
        invalid_properties.push('invalid value for "nonce", nonce cannot be nil.')
      end

      if @recipients.nil?
        invalid_properties.push('invalid value for "recipients", recipients cannot be nil.')
      end

      if @senders.nil?
        invalid_properties.push('invalid value for "senders", senders cannot be nil.')
      end

      if @timestamp.nil?
        invalid_properties.push('invalid value for "timestamp", timestamp cannot be nil.')
      end

      if @transaction_hash.nil?
        invalid_properties.push('invalid value for "transaction_hash", transaction_hash cannot be nil.')
      end

      if @transaction_index.nil?
        invalid_properties.push('invalid value for "transaction_index", transaction_index cannot be nil.')
      end

      if @transaction_status.nil?
        invalid_properties.push('invalid value for "transaction_status", transaction_status cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @fee.nil?
      return false if @gas_limit.nil?
      return false if @gas_price.nil?
      return false if @gas_used.nil?
      return false if @mined_in_block_hash.nil?
      return false if @nonce.nil?
      return false if @recipients.nil?
      return false if @senders.nil?
      return false if @timestamp.nil?
      return false if @transaction_hash.nil?
      return false if @transaction_index.nil?
      return false if @transaction_status.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          fee == o.fee &&
          gas_limit == o.gas_limit &&
          gas_price == o.gas_price &&
          gas_used == o.gas_used &&
          mined_in_block_hash == o.mined_in_block_hash &&
          nonce == o.nonce &&
          recipients == o.recipients &&
          senders == o.senders &&
          timestamp == o.timestamp &&
          transaction_hash == o.transaction_hash &&
          transaction_index == o.transaction_index &&
          transaction_status == o.transaction_status
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [fee, gas_limit, gas_price, gas_used, mined_in_block_hash, nonce, recipients, senders, timestamp, transaction_hash, transaction_index, transaction_status].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = CryptoApis.const_get(type)
        klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
